# -*- coding: utf-8 -*-
"""Wise_Assignment_2.ipynb

Automatically generated by Colaboratory.

Original file is located at
    https://colab.research.google.com/drive/1f-LZGvW9TrHdz26ObP9fqKWUjYEvXCmO
"""

#1
class Counter:
    def __init__(self):
        self.value = 0

    def increment(self):
        self.value += 1

    def reset(self):
        self.value = 0
my_counter = Counter()
my_counter.increment()
my_counter.increment()
my_counter.increment()
print(my_counter.value)
my_counter.reset()
print(my_counter.value)

#2
class Calculator:
    def add(self, a, b):
        return a + b

    def subtract(self, a, b):
        return a - b

    def multiply(self, a, b):
        return a * b

    def divide(self, a, b):
        if b != 0:
            return a / b
calc = Calculator()
print(calc.add(5, 3))       
print(calc.subtract(7, 2))  
print(calc.multiply(4, 6))  
print(calc.divide(10, 2))

#3
class Person:
    count = 0
    def __init__(self, name, age):
        self.name = name
        self.age = age
        Person.count += 1
person1 = Person("Alice", 25)
person2 = Person("Bob", 30)
person3 = Person("Charlie", 35)
print(Person.count)

#4
class BankAccount:
    interest_rate = 0.02
    def __init__(self, account_number, balance):
        self.account_number = account_number
        self.balance = balance
    def deposit(self, amount):
        self.balance += amount
    def withdraw(self, amount):
        if self.balance >= amount:
            self.balance -= amount
        else:
            print("Insufficient balance.")
    @classmethod
    def get_interest_rate(cls):
        return cls.interest_rate
account1 = BankAccount("123456789", 1000)
account2 = BankAccount("987654321", 500)
print(account1.balance)                 
account1.deposit(500)
print(account1.balance)                 
account1.withdraw(2000)                 
print(account1.balance)                 
print(BankAccount.get_interest_rate())

#5
class Triangle:
    def __init__(self, side1, side2, side3):
        self.side1 = side1
        self.side2 = side2
        self.side3 = side3
    def is_equilateral(self):
        return self.side1 == self.side2 == self.side3
triangle1 = Triangle(5, 5, 5)
triangle2 = Triangle(3, 4, 5)
triangle3 = Triangle(1, 1, 1)
print(triangle1.is_equilateral())  
print(triangle2.is_equilateral())  
print(triangle3.is_equilateral())

#6
class Rectangle:
    def __init__(self, width, height):
        self.width = width
        self.height = height
    def area(self):
        return self.width * self.height
    def perimeter(self):
        return 2 * (self.width + self.height)
class Square(Rectangle):
    def __init__(self, side):
        super().__init__(side, side)
rectangle = Rectangle(5, 3)
print(rectangle.area())      
print(rectangle.perimeter()) 
square = Square(4)
print(square.area())         
print(square.perimeter())

#7
class Employee:
    def __init__(self, name, salary):
        self.name = name
        self.salary = salary
    def calculate_bonus(self):
        return 0.1 * self.salary  
class Manager(Employee):
    def calculate_bonus(self):
        return 0.15 * self.salary  
class Developer(Employee):
    def calculate_bonus(self):
        return 0.12 * self.salary  
employee = Employee("John", 5000)
print(employee.calculate_bonus()) 
manager = Manager("Alice", 7000)
print(manager.calculate_bonus())   
developer = Developer("Bob", 6000)
print(developer.calculate_bonus())

#1
class Salesperson:
    def __init__(self, name):
        self.name = name
        self.record = {}
        self.value = 0.0
    def get_name(self):
        return self.name
    def buy_pro(self, product_name, market_price, quantity):
        if product_name in self.record:
            self.record[product_name][1] += quantity
        else:
            self.record[product_name] = [market_price, quantity]
        self.value -= market_price * quantity
    def sell_pro(self, product_name, market_price, quantity):
        if product_name in self.record:
            cost, available_quantity = self.record[product_name]
            if quantity <= available_quantity:
                self.record[product_name][1] -= quantity
                self.value += market_price * quantity
                if self.record[product_name][1] == 0:
                    del self.record[product_name]
            else:
                print("Insufficient quantity.")
        else:
            print("Product not found.")
    def get_record(self):
        return self.record
    def get_value(self):
        return self.value
salesperson = Salesperson("John")
salesperson.buy_pro("ProductA", 10.0, 5)
salesperson.buy_pro("ProductB", 8.0, 3)
salesperson.buy_pro("ProductA", 10.0, 2)
salesperson.sell_pro("ProductA", 12.0, 3)
salesperson.sell_pro("ProductC", 15.0, 2)
salesperson.sell_pro("ProductB", 8.0, 2)
print("Salesperson Name:", salesperson.get_name())
print("Product Record:", salesperson.get_record())
print("Account Value:", salesperson.get_value())

#2
class Records:
    def _init_(self, filename):
        self.student_records = {}
        self.gpa_scale = {
            'A+': 4.3,
            'A': 4.0,
            'A-': 3.7,
            'B+': 3.3,
            'B': 3.0,
            'B-': 2.7,
            'C+': 2.3,
            'C': 2.0,
            'C-': 1.7,
            'D+': 1.3,
            'D': 1.0,
            'D-': 0.7,
            'F': 0.0
        }

        self.load_records(filename)

    def load_records(self, filename):
        with open(filename, 'r') as csv_file:
            for line in csv_file:
                data = line.strip().split(',')
                name = data[0]
                record = data[1:]
                self.student_records[name] = record

    def get_records(self, student):
        if student in self.student_records:
            return self.student_records[student]
        else:
            return "No record found!"

    def insert_record(self, info):
        name = info[0]
        record = info[1:]
        self.student_records[name] = record

    def compute_gpa(self, student):
        if student in self.student_records:
            record = self.student_records[student]
            total_credits = 4 * len(record[1:])
            total_grade_points = 0
            for grade in record[1:]:
                total_grade_points += self.gpa_scale[grade]
            gpa = total_grade_points / total_credits
            return gpa
        else:
            return "No record found!"
records = Records('record.csv')
student_records = records.get_records('John')
print(student_records)
records.insert_record(['Alice', 'Mathematics', 'Senior', 'A', 'B', 'B+', 'A-'])
gpa = records.compute_gpa('John')
print(gpa)

#3
import random
class Card:
    def __init__(self, suit, value):
        self.suit = suit
        self.value = value
    def __repr__(self):
        return f"{self.value} of {self.suit}"
class Deck:
    def __init__(self):
        suits = ['Hearts', 'Diamonds', 'Clubs', 'Spades']
        values = ['A', '2', '3', '4', '5', '6', '7', '8', '9', '10', 'J', 'Q', 'K']
        self.cards = [Card(suit, value) for suit in suits for value in values]
    def shuffle(self):
        random.shuffle(self.cards)
    def deal(self):
        if not self.is_empty():
            return self.cards.pop()
    def is_empty(self):
        return len(self.cards) == 0
deck = Deck()
print("Initial deck:")
print(deck.cards)
deck.shuffle()
print("\nShuffled deck:")
print(deck.cards)
print("\nDealing 5 cards:")
for _ in range(5):
    card = deck.deal()
    if card:
        print(card)
    else:
        print("Deck is empty.")
print("\nRemaining deck:")
print(deck.cards)

#4
class BankAccount:
    def __init__(self, account_number, initial_balance):
        self.account_number = account_number
        self.balance = initial_balance
    def deposit(self, amount):
        self.balance += amount
        print(f"Deposit of Rs. {amount} successful. Current balance: Rs. {self.balance}")
    def withdraw(self, amount):
        if self.balance - amount >= 1000:
            self.balance -= amount
            print(f"Withdrawal of Rs. {amount} successful. Current balance: Rs. {self.balance}")
        else:
            print("Insufficient balance for withdrawal.")
    def get_balance(self):
        return self.balance
class MinimumBalanceAccount(BankAccount):
    def withdraw(self, amount):
        if self.balance - amount >= 1000:
            super().withdraw(amount)
        else:
            print("Minimum balance limit reached. Cannot perform withdrawal.")
account = MinimumBalanceAccount("1234567890", 5000)
print("Initial balance:", account.get_balance())
account.deposit(2000)
account.withdraw(3000)
account.withdraw(5000)
account.deposit(10000)
account.withdraw(8000)
print("Final balance:", account.get_balance())